function [ConcObs,ConcTh,tArr] = react(A0,k1,k2,tArr,percErr)
%REACT calculates the array of concenrations for
% A --> B --> C  where B0 = C0 = 0
  n = length(tArr);
  ConcTh = zeros(n,3);
  ConcObs = zeros(n,3);
  rB = k1/(k2-k1);
  for i=1:n
    t = tArr(i);
    ConcTh(i,1) = A0*exp(-k1*t);
    ConcTh(i,2) = A0*rB*(exp(-k1*t) - exp(-k2*t));
    ConcTh(i,3) = A0 - ConcTh(i,1) - ConcTh(i,2);
    for j=1:3
      ConcObs(i,j) = ConcTh(i,j) * (1+percErr/100*(2*rand-1));
    end
  end
end

