function [ConcObs,ConcTh,tArr] = react2(A0,B0,C0,kr1,kr2,tArr,percErr)
%REACT calculates the array of concentrations for
% A --> B --> C  where B0 = C0 = 0
  global incr
  n = length(tArr);
  ConcTh = zeros(n,3);
  ConcObs = zeros(n,3);
  iData = 1;  
  h = incr/100;
  nSteps = fix((tArr(n)-tArr(1))/h + 0.5);
  t = tArr(1);
  y = [A0 B0 C0];
  for iter=1:nSteps
    if t+h > tArr(iData)
      for j=1:3
        ConcTh(iData,j) = y(j);
      end
      iData = iData + 1;
    end
    k1 = h*fx(y,kr1,kr2);
    k2 = h*fx(y+k1/4,kr1,kr2);
    k3 = h*fx(y+(3*k1+9*k2)/32,kr1,kr2);
    k4 = h*fx(y+(1932*k1-7200*k2+7296*k3)/2197,kr1,kr2);
    k5 = h*fx(y+439/216*k1-8*k2+3680/513*k3-845/4104*k4,kr1,kr2);
    k6 = h*fx(y - 8/27*k1 + 2*k2 -3544/2565*k3 +1859/4104*k4 -11/40*k5,kr1,kr2);
    y = y + 16/135*k1 + 6656/12825*k3 + 28561/56430*k4 - 9/50*k5 + 2/55*k6;
    t = t + h;
  end
  
  for j=1:3
    ConcTh(iData,j) = y(j);
  end
  
  for i=1:n
    for j=1:3
      ConcObs(i,j) = ConcTh(i,j) * (1+percErr/100*(2*rand-1));
    end
  end
end

function y = fx(x,k1,k2)
  y(1) = -k1*x(1);
  y(2) = k1*x(1)-k2*x(2);
  y(3) = k2*x(2);
end


