function [ConcObs,ConcTh,tArr] = react(A0,k1,k2,k3,tArr,percErr)
%REACT calculates teh array of concenrations for
% A --> B --> C --> D where B0 = C0 = D0 = 0
  n = length(tArr);
  ConcTh = zeros(n,4);
  ConcObs = zeros(n,4);
  rB = k1/(k2-k1);
  c0 = k1*k2;
  c1 = (k2-k1)*(k3-k1);
  c2 = (k1-k2)*(k3-k2);
  c3 = (k1-k3)*(k2-k3);
  for i=1:n
    t = tArr(i);
    ConcTh(i,1) = A0*exp(-k1*t);
    ConcTh(i,2) = A0*rB*(exp(-k1*t) - exp(-k2*t));
    ConcTh(i,3) = A0*c0*(exp(-k1*t)/c1 + exp(-k2*t)/c2 + exp(-k3*t)/c3);
    ConcTh(i,4) = A0 - ConcTh(i,1) - ConcTh(i,2) - ConcTh(i,3);
    for j=1:4
      ConcObs(i,j) = ConcTh(i,j) * (1+percErr/100*(2*rand-1));
    end
  end
end

