%  A ==> B
%  A ==> C
% A0 > 0  
% All reactions are first order 
clc
close 
clear all
global tData
global yData
global incr
fprintf('A ==> B and A ==> C\n');
fprintf('A0 > 0\n');
fprintf('All reactions are first order\n');
fprintf('Wait please ...\n');
A0 = 100;
k(1) = 0.05;
k(2) = 0.15;
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Pobs,Pth,tArr] = react(A0,k,tArr,10);
tData = tArr;
yData = Pobs;

fcn = @rkf5;
nvars = 3;
lb = [50 .01 0.01];
ub = [200 1 1];
options = optimoptions('particleswarm', 'Display', 'iter');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub);
A00 = bestX(1);
k1 = bestX(2);
k2 = bestX(3);
fprintf('\nBest A0=%f, k1=%f, k2=%f\n', A0, k1, k2);
fprintf('Best fx = %e\n', bestFx);
n = length(tArr);
Pcalc = zeros(n,2);
for i=1:n
  Pcalc(i,1) = A00*(1-exp(-k1*tArr(i)));
  Pcalc(i,2) = A00*(1-exp(-k2*tArr(i)));
end  

figure(1)
plot(tArr,Pth(:,1),tArr,Pobs(:,1),'r',tArr,Pcalc(:,1),'g'); 
title('Concentration of B');
xlabel('time');
ylabel('Concentration');
grid;

figure(2)
plot(tArr,Pth(:,2),tArr,Pobs(:,2),'r',tArr,Pcalc(:,2),'g'); 
title('Concentration of C');
xlabel('time');
ylabel('Concentration');
grid;

fprintf('For product B\n');
j=1;
for i=2:n
  err1 = (Pcalc(i,j) - Pth(i,j))/Pth(i,j)*100;
  err2 = (Pcalc(i,j) - Pobs(i,j))/Pobs(i,j)*100;
  fprintf('%f %f %f %f %f\n', Pth(i,j), Pobs(i,j), Pcalc(i,j), err1, err2);
end

fprintf('For product C\n');
j=2;
for i=2:n
  err1 = (Pcalc(i,j) - Pth(i,j))/Pth(i,j)*100;
  err2 = (Pcalc(i,j) - Pobs(i,j))/Pobs(i,j)*100;
  fprintf('%f %f %f %f %f\n', Pth(i,j), Pobs(i,j), Pcalc(i,j), err1, err2);
end

fprintf('\n\n');
for j=1:2
  if j==1
    fprintf('For product B\n');
  else
    fprintf('For product C\n');
  end
  fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Pth(:,j),Pcalc(:,j)));
  fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Pobs(:,j),Pcalc(:,j)));
end