function sumSqrErr = rkf5(x)
% rkf5arr implements Runge-Kutta-Fehlberg
%   Detailed explanation goes here
  global tData
  global yData  
  global incr;
  A0 = x(1);
  k(1) = x(2);
  k(2) = x(3);
  k(3) = x(4);
  k1 = zeros(3,1);
  k2 = k1;
  k2 = k1;
  k3 = k1;
  k4 = k1;
  k5 = k1;
  k6 = k1;
  iData = 1;  
  nData = length(tData);
  h = incr/10;
  nSteps = fix((tData(nData)-tData(1))/h + 0.5);
  sumSqrErr = 0;
  t = tData(1);
  y = [0 0 0];
  for iter=1:nSteps
    if t+h > tData(iData)
      for j=1:3
        sumSqrErr = sumSqrErr + (y(j) - yData(iData,j))^2;
      end
      iData = iData + 1;
    end
    for j=1:3
      k1(j) = h*fx(y(j),k(j),A0);
    end
    for j=1:3
      k2(j) = h*fx(y(j)+k1(j)/4,k(j),A0);
    end
    for j=1:3
      k3(j) = h*fx(y(j)+(3*k1(j)+9*k2(j))/32,k(j),A0);
    end
    for j=1:3
      k4(j) = h*fx(y(j)+(1932*k1(j)-7200*k2(j)+7296*k3(j))/2197,k(j),A0);
    end
    for j=1:2
      k5(j) = h*fx(y(j)+439/216*k1(j)-8*k2(j)+3680/513*k3(j)-845/4104*k4(j),k(j),A0);
    end
    for j=1:3
      k6(j) = h*fx(y(j) - 8/27*k1(j) + 2*k2(j) -3544/2565*k3(j) + ...4
        1859/4104*k4(j) -11/40*k5(j),k(j),A0);
    end
    for j=1:3
      y(j) = y(j) + 16/135*k1(j) + 6656/12825*k3(j) + 28561/56430*k4(j) - ...
        9/50*k5(j) + 2/55*k6(j);
    end
    t = t + h;
  end
end

function y = fx(A,k,A0)
  y = k*(A0-A);
end

