%  A <==> B
% A0 > 0 and B0 = 0 
% All reactions are first order 
clc
close 
clear all
global tData
global aData
global bData
global incr
fprintf('A <==> B\n');
fprintf('A0 > 0 and B0 = 0\n');
fprintf('All reactions are first order\n');
fprintf('Wait please ...\n');
A0 = 100;
B0 = 0;
k1 = 0.05;
k2 = 0.005;
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Aobs,Ath,Bobs,Bth,tArr] = react(A0,k1,k2,tArr,10);
tData = tArr;
aData = Aobs;
bData = Bobs;

fcn = @rkf5;
nvars = 3;
lb = [50 .01 0.001];
ub = [200  .2 .02];
options = optimoptions('particleswarm', 'SwarmSize', 500, 'MaxIterations', 5000, ...
   'DisplayInterval', 100);
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub,options);
fprintf('\nBest A0=%f, k1=%f, B0=%f, k2=%f\n', bestX(1), bestX(2), 0, bestX(3));
fprintf('Best fx = %e\n', bestFx);
% [bestX, bestFx] = scout([50 .01], [200 .1], [10 .01], [.1 .001], 10000, 100, 50, false, true)
n = length(tArr);
Acalc = zeros(n,1);
Bcalc = Acalc;
A00 = bestX(1);
B00 = 0;
kk1 = bestX(2);
kk2 = bestX(3);
beta = kk1 + kk2;
r = kk1/kk2;
xinf = r*A00/(1+r);
for i=1:n
  x = xinf*(1 - exp(-beta*tArr(i)));
  Acalc(i) = A00 - x;
  Bcalc(i) = B00 + x;
end  

figure(1)
plot(tArr,Ath,tArr,Aobs,'r',tArr,Acalc,'g'); 
title('Concentration of A');
xlabel('Time');
ylabel('Concentration');
grid;

figure(2)
plot(tArr,Bth,tArr,Bobs,'r',tArr,Bcalc,'g'); 
title('Concentration of B');
xlabel('Time');
ylabel('Concentration');
grid;

fprintf('For concentration os A\n');
for i=1:n
  if Ath(i)~=0
    err1 = (Acalc(i) - Ath(i))/Ath(i)*100;
    err2 = (Acalc(i) - Aobs(i))/Aobs(i)*100;
    fprintf('%f %f %f %f %f\n', Ath(i), Aobs(i), Acalc(i), err1, err2);
  end
end
fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Ath,Acalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Aobs,Acalc));

fprintf('For concentration os B\n');
for i=1:n
  if Bth(i)~=0
    err1 = (Bcalc(i) - Bth(i))/Bth(i)*100;
    err2 = (Bcalc(i) - Bobs(i))/Bobs(i)*100;
    fprintf('%f %f %f %f %f\n', Bth(i), Bobs(i), Bcalc(i), err1, err2);
  end
end
fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Bth,Bcalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Bobs,Bcalc));
