function sumSqrErr = rkf5(x)
% rkf5arr implements Runge-Kutta-Fehlberg
%   Detailed explanation goes here
  global tData
  global aData  
  global bData
  global incr;
  A0 = x(1);
  kr1 = x(2);
  kr2 = x(3);
  r = kr1/kr2;
  xinf = r*A0/(1+r);
  iData = 1;  
  nData = length(tData);
  h = incr/10;
  nSteps = fix((tData(nData)-tData(1))/h + 0.5);
  sumSqrErr = 0;
  t = tData(1);
  y = 0;
  for iter=1:nSteps
    if t+h > tData(iData)
      concA = A0 - y;
      concB = y;
      sumSqrErr = sumSqrErr + (concA - aData(iData))^2 + (concB - bData(iData))^2;
      iData = iData + 1;
    end
    k1 = h*fx(y,A0,kr1,xinf);
    k2 = h*fx(y+k1/4,A0,kr1,xinf);
    k3 = h*fx(y+(3*k1+9*k2)/32,A0,kr1,xinf);
    k4 = h*fx(y+(1932*k1-7200*k2+7296*k3)/2197,A0,kr1,xinf);
    k5 = h*fx(y+439/216*k1-8*k2+3680/513*k3-845/4104*k4,A0,kr1,xinf);
    k6 = h*fx(y - 8/27*k1 + 2*k2 -3544/2565*k3 +1859/4104*k4 -11/40*k5,A0,kr1,xinf);
    y = y + 16/135*k1 + 6656/12825*k3 + 28561/56430*k4 - 9/50*k5 + 2/55*k6;
    t = t + h;
  end
end

function y = fx(x,A0,k1,xinf)
  y = k1*A0*(xinf - x)/xinf;
end


