% A + pB ==> C
% A0 > 0 and B0 > 0 
% All reactions are first order 
clc
close 
clear all
global tData
global yData
global incr
global p
fprintf('A + pB ==> C\n');
fprintf('A0 > 0 and B0 > 0\n');
fprintf('Reaction is second order\n');
fprintf('Wait please ...\n');
A0 = 100;
B0 = 80;
k = 0.002;
p = 2; % A + pB --> X
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Xobs,Xth,tArr] = react(A0,B0,k,tArr,10);
% plot(tArr,Ath,tArr,Aobs);
% grid
tData = tArr;
yData = Xobs;

fcn = @rkf5;
nvars = 3;
lb = [50 50 .001];
ub = [200 200 .01];
fprintf('Please wait .....\n');
options = optimoptions('particleswarm', 'SwarmSize', 200, 'MaxIterations', 2000, ...
   'DisplayInterval', 100, 'FunValCheck' , 'on');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub,options);
fprintf('Reaction is A + %iB --> X\n', p);
fprintf('\nBest A0=%f, B0=%f, k=%f\n', bestX(1), bestX(2), bestX(3));
fprintf('Best fx = %e\n', bestFx);
% [bestX, bestFx] = scout([50 .01], [200 .1], [10 .01], [.1 .001], 10000, 100, 50, false, true)
n = length(tArr);
Xcalc = zeros(n,1);
A00 = bestX(1);
B00 = bestX(2);
kk = bestX(3);

K = kk*(p*A00 - B00);
r = A00/B00;
c = (B00 - p*A00)*r;
for i=1:n
  ex = exp(K*tArr(i));
  Acalc = c*ex/(1 - p*r*ex);
  Xcalc(i) = A00 - Acalc;  
end  

plot(tArr,Xth,tArr,Xobs,'r',tArr,Xcalc,'g'); 
grid;

fprintf('Data for Reactant X\n');
for i=2:n
  err1 = (Xcalc(i) - Xth(i))/Xth(i)*100;
  err2 = (Xcalc(i) - Xobs(i))/Xobs(i)*100;
  fprintf('%f %f %f %f %f\n', Xth(i), Xobs(i), Xcalc(i), err1, err2);
end

fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Xth,Xcalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Xobs,Xcalc));