function sumSqrErr = rkf5(x)
% rkf5arr implements Runge-Kutta-Fehlberg
%   Detailed explanation goes here
  global tData
  global yData  
  global incr;
  global p;
  A0 = x(1);
  B0 = x(2);
  k = x(3);
  iData = 1;  
  nData = length(tData);
  h = incr/10;
  nSteps = fix((tData(nData)-tData(1))/h + 0.5);
  sumSqrErr = 0;
  t = tData(1);
  y = yData(iData);
  for iter=1:nSteps
    if t+h > tData(iData)
      sumSqrErr = sumSqrErr + (y - yData(iData))^2;
      iData = iData + 1;
    end
    k1 = h*fx(y,k,A0,B0);
    k2 = h*fx(y+k1/4,k,A0,B0);
    k3 = h*fx(y+(3*k1+9*k2)/32,k,A0,B0);
    k4 = h*fx(y+(1932*k1-7200*k2+7296*k3)/2197,k,A0,B0);
    k5 = h*fx(y+439/216*k1-8*k2+3680/513*k3-845/4104*k4,k,A0,B0);
    k6 = h*fx(y - 8/27*k1 + 2*k2 -3544/2565*k3 +1859/4104*k4 -11/40*k5,k,A0,B0);
    y = y + 16/135*k1 + 6656/12825*k3 + 28561/56430*k4 - 9/50*k5 + 2/55*k6;
    t = t + h;
  end
end

function y = fx(X,k,A0,B0)
  global p
  if (A0-X)>0 && (B0-p*X)>0
    y = k*(A0-X)*(B0-p*X);
  else
    y = 0;
    % fprintf('reaction stopped!\n');
  end
end

