% Reversible Reaction
% 2A <===> C + D
% A0 > 0, C0 = 0, and D0 - 0
% -rA = k1*A^2 - k2*C*D
clc
close 
clear all
global tData
global yData
global incr
fprintf('2A <===> C + D\n');
fprintf('A0 > 0, C0 = 0, and D0 - 0 > 0\n');
fprintf('-rA = k1*A^2 - k2*C*D\n');
fprintf('Wait please ...\n');
A0 = 1;
k1 = 0.5;
k2 = 0.1;
tArr = [0.5 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Aobs,Ath,tArr] = react(A0,k1,k2,tArr,10);
tData = tArr;
yData = Aobs;

fcn = @rkf5;
nvars = 3;
lb = [A0 k1 k2]/1.05;
ub = 1.05^2*lb;
options = optimoptions('particleswarm', 'Display', 'iter');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub);
fprintf('\nBest A0=%f, k1=%f, and k2=%f\n', bestX(1), bestX(2), bestX(3));
fprintf('Best fx = %e\n', bestFx);
n = length(tArr);
Acalc = zeros(n,1);
A00 = bestX(1);
kk1 = bestX(2);
kk2 = bestX(3);
[Acalc,~,tArr] = react(A00,kk1,kk2,tArr,10);

plot(tArr,Ath,tArr,Aobs,'r',tArr,Acalc,'g'); 
title('Concentration of A');
xlabel('Time');
ylabel('Concentration');
grid;

fprintf('Data for Reactant A\n');
for i=1:n
  err1 = (Acalc(i) - Ath(i))/Ath(i)*100;
  err2 = (Acalc(i) - Aobs(i))/Aobs(i)*100;
  fprintf('%f %f %f %f %f\n', Ath(i), Aobs(i), Acalc(i), err1, err2);
end

fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Ath,Acalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Aobs,Acalc));