function [Aobs,Ath,tArr] = react(A0,k1,k2,tArr,percErr)
%REACT2 calculates the array of concenrations for reactant A
% Reversible Reaction
% 2A <=> C + D
% -rA = k1*A^2 - k2*C*D
  n = length(tArr);
  Ath = zeros(1,n);
  Aobs = zeros(1,n);
  K = k2/k1;
  K4 = K/4;
  K4p = 1 + K4;
  K4m = 1 - K4;
  delta = 2*A0*k1*K;
  alpha = A0*(1+sqrt(K4))/K4m;
  beta = A0*(1-sqrt(K4))/K4m;
  gamma = K4p/K4m;
  for i=1:n
    t = tArr(i);
    ex = exp(delta*t);
    y = (beta*gamma*ex - alpha)/(ex - 1);
    Ath(i) = A0 - y;
    Aobs(i) = Ath(i) * (1+percErr/100*(2*rand-1));
  end
end

