% A + B ==> C
% A0 > 0 and B0 > 0 
% Reaction is second order 
clc
close 
clear all
global tData
global yData
global incr
fprintf('A + B ==> C\n');
fprintf('A0 > 0 and B0 > 0\n');
fprintf('Reaction is second order\n');
fprintf('Wait please ...\n');
A0 = 100;
B0 = 80;
k = 0.005;
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Aobs,Ath,tArr] = react(A0,B0,k,tArr,10);
% plot(tArr,Ath,tArr,Aobs);
% grid
tData = tArr;
yData = Aobs;

fcn = @rkf5;
nvars = 3;
lb = [A0 B0 k]/1.05;
ub = 1.05^2*lb;
options = optimoptions('particleswarm', 'Display', 'iter');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub);
fprintf('\nBest A0=%f, B0=%f, k=%f\n', bestX(1), bestX(2), bestX(3));
fprintf('Best fx = %e\n', bestFx);
n = length(tArr);
Acalc = zeros(n,1);
A00 = bestX(1);
B00 = bestX(2);
kk = bestX(3);
for i=1:n
  K = kk*(A00 - B00);
  r = A00/B00;
  c = (B00 - A00)*r;
  ex = exp(K*tArr(i));
  Acalc(i) = c*ex/(1 - r*ex);
end  

plot(tArr,Ath,tArr,Aobs,'r',tArr,Acalc,'g'); 
grid;

fprintf('Data for Reactant A\n');
for i=1:n
  err1 = (Acalc(i) - Ath(i))/Ath(i)*100;
  err2 = (Acalc(i) - Aobs(i))/Aobs(i)*100;
  fprintf('%f %f %f %f %f\n', Ath(i), Aobs(i), Acalc(i), err1, err2);
end

fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Ath,Acalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Aobs,Acalc));