% A <==> B
% A0 > 0 
% Reaction is second order 
clc
close 
clear all
global tData
global yData
global incr
fprintf('A ==> B\n');
fprintf('A0 > 0\n');
fprintf('Reaction is second order\n');
fprintf('Wait please ...\n');
A0 = 100;
k = 0.05;
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Aobs,Ath,tArr] = react2(A0,k,tArr,10);
tData = tArr;
yData = Aobs;

fcn = @rkf5;
nvars = 2;
lb = [50 .01];
ub = [200 .1];
options = optimoptions('particleswarm', 'Display', 'iter');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub);
fprintf('\nBest A0=%f, k=%f\n', bestX(1), bestX(2));
fprintf('Best fx = %e\n', bestFx);
n = length(tArr);
Acalc = zeros(n,1);
for i=1:n
  Acalc(i) = 1/(1/bestX(1) + bestX(2)*tArr(i));
end  

plot(tArr,Ath,tArr,Aobs,'r',tArr,Acalc,'g'); 
grid;

for i=1:n
  err1 = (Acalc(i) - Ath(i))/Ath(i)*100;
  err2 = (Acalc(i) - Aobs(i))/Aobs(i)*100;
  fprintf('%f %f %f %f %f\n', Ath(i), Aobs(i), Acalc(i), err1, err2);
end
fprintf('\n\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Ath,Acalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Aobs,Acalc));