% Reversible Reaction:
% A + B <---> C
% A0 = B0 > 0 and C0 = 0
% -rA = k1*A*B - k2*C
clc
close 
clear all
fprintf('A + B <---> C\n');
fprintf('A0 = B0 > 0 and C0 = 0\n');
fprintf('-rA = k1*A*B - k2*C\n');
fprintf('Wait please ...\n\n');
global tData
global yData
global incr
A0 = 1;
k1 = 0.5;
k2 = 0.1;
tArr = [0 1.2 2.2 3.3 4.5 5.3 6.1 6.9 7.2 7.9 8.1 8.8 9.3 10];
% tArr = [0 1 2 3 5 7 9 10 12];
incr = findMinDigit(tArr);
[Aobs,Ath,tArr] = react(A0,k1,k2,tArr,10);
Cth = A0 - Ath;
Cobs = A0 - Aobs;
tData = tArr;
yData = Aobs;

fcn = @rkf5;
nvars = 3;
cf = 1.05;
lb = [A0 k1 k2]/cf;
ub = cf^2*lb;
options = optimoptions('particleswarm', 'Display', 'iter');
[bestX, bestFx] = particleswarm(fcn,nvars,lb,ub);
fprintf('\nBest A0=%f, k1=%f, and k2=%f\n', bestX(1), bestX(2), bestX(3));
fprintf('Best fx = %e\n', bestFx);
n = length(tArr);
Acalc = zeros(n,1);
A00 = bestX(1);
kk1 = bestX(2);
kk2 = bestX(3);
[~,Acalc,tArr] = react(A00,kk1,kk2,tArr,0);
Ccalc = A00 - Acalc;
figure(1)
plot(tArr,Ath,tArr,Aobs,'r',tArr,Acalc,'g'); 
title('Concentration of A');
xlabel('Time');
ylabel('Concentration');
grid;

figure(2)
plot(tArr,Cth,tArr,Cobs,'r',tArr,Ccalc,'g'); 
title('Concentration of C');
xlabel('Time');
ylabel('Concentration');
grid;

fprintf('For reactanat A (same as B):\n');
for i=1:n
  err1 = (Acalc(i) - Ath(i))/Ath(i)*100;
  err2 = (Acalc(i) - Aobs(i))/Aobs(i)*100;
  fprintf('%f %f %f %f %f\n', Ath(i), Aobs(i), Acalc(i), err1, err2);
end
fprintf('\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Ath,Acalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Aobs,Acalc));

fprintf('For reactanat C):\n');
for i=1:n
  err1 = (Ccalc(i) - Cth(i))/Cth(i)*100;
  err2 = (Ccalc(i) - Cobs(i))/Cobs(i)*100;
  fprintf('%f %f %f %f %f\n', Cth(i), Cobs(i), Ccalc(i), err1, err2);
end
fprintf('\n');
fprintf('R^2 = %f for comparing theoretical and calculated values\n', rsqr(Cth,Ccalc));
fprintf('R^2 = %f for comparing observed and calculated values\n', rsqr(Cobs,Ccalc));