function [Aobs,Ath,tArr] = react(A0,k1,k2,tArr,percErr)
%REACT calculates teh array of concenrations for A
% Reversible Reaction:
% A + B <---> C
% A0 = B0 > 0 and C0 = 0
% -rA = k1*A*B - k2*C
  n = length(tArr);
  Ath = zeros(1,n);
  Aobs = zeros(1,n);
  xeq = calcXeq(A0,k1,k2);
  alpha = k1*(A0^2 - xeq^2)/xeq;
  beta = xeq/A0;
  for i=1:n
    t =tArr(i);
    ex = exp(-alpha*t);
    x = (A0*beta*ex - xeq)/(beta*xeq*ex-1);
    Ath(i) = A0 - x;
    Aobs(i) = Ath(i) * (1+percErr/100*(2*rand-1));
  end
end

