function [Aobs,Ath,tArr] = react(A0,kr1,kr2,tArr,percErr)
%REACT calculates teh array of concenrations for A
% Reversible Reaction:
% A + B <---> C
% A0 = B0 > 0 and C0 = 0
 global incr
  n = length(tArr);
  Ath = zeros(n,1);
  Aobs = zeros(n,1);
  iData = 1;  
  h = incr/100;
  nSteps = fix((tArr(n)-tArr(1))/h + 0.5);
  t = tArr(1);
  y = 0;
  for iter=1:nSteps
    if t+h > tArr(iData)
     Ath(iData) = A0 - y;
     iData = iData + 1;
    end
    k1 = h*fx(y,A0,kr1,kr2);
    k2 = h*fx(y+k1/4,A0,kr1,kr2);
    k3 = h*fx(y+(3*k1+9*k2)/32,A0,kr1,kr2);
    k4 = h*fx(y+(1932*k1-7200*k2+7296*k3)/2197,A0,kr1,kr2);
    k5 = h*fx(y+439/216*k1-8*k2+3680/513*k3-845/4104*k4,A0,kr1,kr2);
    k6 = h*fx(y - 8/27*k1 + 2*k2 -3544/2565*k3 +1859/4104*k4 -11/40*k5,A0,kr1,kr2);
    y = y + 16/135*k1 + 6656/12825*k3 + 28561/56430*k4 - 9/50*k5 + 2/55*k6;
    t = t + h;
  end
  
  Ath(iData) = A0 - y;
  
  for i=1:n
    Aobs(i) = Ath(i) * (1+percErr/100*(2*rand-1));
  end
end

function y = fx(x,A0,k1,k2)
  y = k1*(A0-x)^2 - k2*x*x;
end

