function [Xobs,Xth,tArr] = react(A0,k1,k2,tArr,percErr)
%REACT calculates the array of concenration FRACTIONS for
% A + B <==> R + S, with [A0] = [B0] and [R0] = [S0] = 0
  n = length(tArr);
  Xth = zeros(1,n);
  Xobs = Xth;
  Keq = k1/k2;
  SqrtKeq = sqrt(Keq);
  xinf = SqrtKeq/(1 + SqrtKeq);
  m = 2*k1*A0*(1-xinf)/xinf;
  for i=1:n
    ex =exp(-m*tArr(i));
    x =xinf*(1-ex)/(1 + (1-2*xinf)*ex);
    Xth(i) = x;
    Xobs(i) = Xth(i) * (1+percErr/100*(2*rand-1));
  end
end

