function [Xobs,Xth,xeq,tArr] = react(A0,k1,k2,tArr,percErr)
%REACT calculates the array of concenration FRACTIONS for
% A <==> R, with [A0] > 0 and [R0] = 0
  n = length(tArr);
  Xth = zeros(1,n);
  Xobs = Xth;
  K = k1/k2;
  sK = sqrt(K);
  m = 2*k1*A0/sK;
  xeq = sK/(1+sK);
  for i=1:n
    t = tArr(i);
    ex = exp(m*t);
    Xth(i) =  xeq *(ex-1)/(1-2*xeq+ex);
    Xobs(i) = Xth(i) * (1 + percErr/100*(2*rand-1));
  end    
end

