function [bestX,bestFx] = pso(fx,XLow,XHi,Vmax,MaxPop,MaxIters)
%PSO Summary of this function goes here

  n = length(XLow);
  if length(Vmax)<n, Vmax = Vmax + zeros(1,n); end
  if length(XHi)<n, XHi = XHi + zeros(1,n); end
  m = n + 1;
  Pop = zeros(MaxPop,m);
  v = zeros(MaxPop,n);
  c1 = 2.05;
  c2 = 2.05;
  
  for i=1:MaxPop
    for j=1:n
      v(i,j) = Vmax(j) * (2*rand - 1);
    end
    Pop(i,1:n) = XLow + (XHi - XLow) .* rand(1,n);
    Pop(i,m) = fx(Pop(i,1:n));
  end
  Pop = sortrows(Pop, m);
  BestPop = Pop;
  
  for iter=1:MaxIters
    w = 0.9 - 0.5*(iter-1)/(MaxIters-1);
    for i=2:MaxPop
      for j=1:n
        r1 = rand;
        r2 = rand;
        v(i,j) = w*v(i,j) + c1*r1*(BestPop(i,j) - Pop(i,j)) + ...
                            c2*r2*(Pop(1,j) - Pop(i,j));   
        if v(i,j) < -Vmax(j), v(i,j) = -Vmax(j) * rand; end
        if v(i,j) > Vmax(j),  v(i,j) = Vmax(j) * rand; end
        Pop(i,j) = Pop(i,j) + v(i,j);
        if Pop(i,j) < XLow(j) || Pop(i,j) > XHi(j)
          Pop(i,j) = XLow(j) + (XHi(j) - XLow(j)) * rand;
        end
      end
      Pop(i,m) = fx(Pop(i,1:n));
      if Pop(i,m) < BestPop(i,m)
        BestPop(i,:) = Pop(i,:);
      end
    end
    Pop = sortrows(Pop, m);
    BestPop = sortrows(BestPop, m);
  end
  
  bestX = Pop(1,1:n);
  bestFx = Pop(1,m);
end

