function [Xobs,Xth,tArr] = react1(A0,B0,R0,S0,k1,k2,tArr,percErr)
%REACT calculates the array of concenration FRACTIONS for
% A + B <==> R + S, with all chemcials's conc > 0
% (-rA) = k1*A*B - k2*R*S
  n = length(tArr);
  Xth = zeros(1,n);
  Xobs = Xth;
  Keq = k1/k2;
  Mra = R0/A0;
  Msa = S0/A0;
  Mba = B0/A0;
  Mbs = B0/S0;
  a = A0 *(1 +  1/Keq);
  b = -A0*(1 + Mba + (Mra + Mbs)/Keq);
  c = A0*(Mba - Mra*Msa/Keq);
  if b^2 > 4*a*c
    D1 = sqrt(b^2 - 4*a*c);
    K = k1*D1;
    Bp = b+D1;
    Bm = b-D1;
    B1 = Bm/Bp; 
    Cm = Bm/2/a;
    Cp = Bp/2/a;    
    for i=1:n
      t = tArr(i);
      x = (Cp*B1 - Cm*exp(-K*t))/(exp(-K*t) - B1);
      Xth(i) = x;
      Xobs(i) = x * (1 + percErr/100*(2*rand-1));
    end
  elseif b^2 < 4*a*c
    D2 = sqrt(4*a*c - b^2);
    K = k2*D2/2;
    for i=1:n
      t = tArr(i);
      x = (D2*tan(K*t + atan(b/D2)) - b)/(2*a);
      Xth(i) = x;
      Xobs(i) = x * (1 + percErr/100*(2*rand-1));
    end    

  else
   for i=1:n
      t = tArr(i);
      x = ((k1*t * b)*b/4/a) / (1 - (k1*t * b)/2);
      Xth(i) = x;
      Xobs(i) = x * (1 + percErr/100*(2*rand-1));
    end       
  end
end

